unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Windows,
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    ApplicationProperties1: TApplicationProperties;
    Button1: TButton;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ListBox1: TListBox;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PageControl1: TPageControl;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    RadioButton1: TRadioButton;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ToggleBox1: TToggleBox;
    TrayIcon1: TTrayIcon;
    procedure ApplicationProperties1Minimize(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ApplicationProperties1Minimize(Sender: TObject);
begin
  Form1.Hide;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  case Form1.WindowState of
    wsFullScreen: ShowMessage('wsFullScreen');
    wsMaximized:  ShowMessage('wsMaximized');
    wsMinimized:  ShowMessage('wsMinimized');
    wsNormal:     ShowMessage('wsNormal');
  end;

  case Form1.Visible of
    True:         ShowMessage('Form1.Visible = True');
    False:        ShowMessage('Form1.Visible = False');
  end;
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  Form1.ShowOnTop; // sets WindowState, Visible, and calls BringToFront
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
var
  h: THandle;
begin
  h := FindWindow(nil, 'Form1');
  SetForegroundWindow(h);
  ShowWindow(h, SW_RESTORE);

  // Form1.WindowState is still wsMinimized
  // Form1.Visible is still false
  // Taskbar icon is not restored
  // TLabel and TImage components are not drawn
end;

end.

